// ~~ Generated by Modular Boilerplate ~~
const commaDangle = {
  arrays: 'always-multiline',
  objects: 'always-multiline',
  functions: 'never',
  imports: 'never',
  exports: 'never',
};

const basicOverridesForTS = {
  env : {
    browser: true,
    jest: true,
    node: true,
    es6: true,
  },
  extends: [
    'plugin:@typescript-eslint/recommended',
    'airbnb-typescript',
  ],
  parser: '@typescript-eslint/parser',
  parserOptions: {
    ecmaVersion: 2018,
    sourceType: 'module',
  },
  plugins: [
    '@typescript-eslint',
  ],
  rules: {
    '@typescript-eslint/no-shadow': 'warn',
    '@typescript-eslint/no-unused-vars': 'warn',
    'import/no-extraneous-dependencies': 'off',
    'import/no-cycle': [2, { maxDepth: 1 }],
    '@typescript-eslint/comma-dangle': ['error', {
      ...commaDangle,
      enums: 'always-multiline',
      generics: 'never',
      tuples: 'never',
    }],
  },
};

const preactOverrides = {
  ...basicOverridesForTS,
  env : basicOverridesForTS.env,
  extends: [
    ...basicOverridesForTS.extends,
    'plugin:react/recommended',
  ],
  settings: {
    react: {
      pragma: 'h',
    },
  },
  parserOptions: {
    ...basicOverridesForTS.parserOptions,
    project: 'tsconfig.app.json',
  },
  rules: {
    ...basicOverridesForTS.rules,
    'react/react-in-jsx-scope': 'off',
    'react/prop-types': 'off',
    'react/no-unknown-property': ['error', {
      ignore: ['class'],
    }],
    'react/require-default-props': 'off',
  },
};

module.exports = {
  root: true,
  env: {
    es2021: true,
    node: true,
  },
  extends: [
    'eslint:recommended',
    'plugin:import/recommended',
    'plugin:import/typescript',
  ],
  rules: {
    'quotes': ['error', 'single', { avoidEscape: true }],
    'comma-spacing': ['error', { before: false, after: true }],
    'semi': ['error', 'always'],
    'import/prefer-default-export': 'off',
    'import/namespace': 'off',
    'import/order': [
      1, {
       groups: [
          'external',
          'builtin',
          'internal',
          'sibling',
          'parent',
          'index',
        ],
      },
    ],
    'comma-dangle': ['error', commaDangle],
    'max-len': [
      'error',
      {
        code: 150,
        ignoreUrls: true,
        ignoreStrings: true,
        ignoreTemplateLiterals: true,
        ignoreComments: true,
        ignoreRegExpLiterals: true,
      },
    ],
    'quote-props': ['error', 'consistent-as-needed'],
    'array-bracket-spacing': [
      'error',
      'never',
    ],
    'array-bracket-newline': ['error', 'consistent'],
    'object-curly-spacing': ['error', 'always'],
    'object-curly-newline': ['error', { multiline: true, consistent: true }],
    'object-property-newline': ['error', { allowAllPropertiesOnSameLine: true }],
    'keyword-spacing': ['error'],
  },
  plugins: ['import'],
  overrides: [
    {
      ...preactOverrides,
      files: ['{src,test}/**/*.{ts,tsx}'],
    },
    {
      ...basicOverridesForTS,
      files: [
        '{infrastructure,template}/**/*.ts',
      ],
      parserOptions: {
        ...basicOverridesForTS.parserOptions,
        project: 'tsconfig.dev.json',
      },
    },
    {
      files: ['test/**/*.{ts,tsx}'],
      rules: {
        'import/no-extraneous-dependencies': 'off',
        '@typescript-eslint/ban-ts-comment': 'off',
        '@typescript-eslint/no-explicit-any': 'off',
      },
    },
  ],
};
